diff -u2 -r goldware.2/golded3/gckeys.cpp goldware/golded3/gckeys.cpp
--- goldware.2/golded3/gckeys.cpp	Sat Feb  6 16:00:20 1999
+++ goldware/golded3/gckeys.cpp	Tue Mar 23 15:27:28 1999
@@ -131,4 +131,17 @@
   { Key_C_U     , KK_EditUnDelete         , KT_E },
   { Key_A_Z     , KK_EditZapQuoteBelow    , KT_E },
+#if defined(__MSDOS__) or defined(__OS2__)
+  { Key_C_Ins   , KK_EditCopy             , KT_E },
+  { Key_C_Del   , KK_EditCut              , KT_E },
+  { Key_S_Ins   , KK_EditPaste            , KT_E },
+  { Key_S_PgUp  , KK_EditBlockPgUp        , KT_E },
+  { Key_S_PgDn  , KK_EditBlockPgDn        , KT_E },
+  { Key_S_Home  , KK_EditBlockHome        , KT_E },
+  { Key_S_End   , KK_EditBlockEnd         , KT_E },
+  { Key_S_Up    , KK_EditBlockUp          , KT_E },
+  { Key_S_Dwn   , KK_EditBlockDown        , KT_E },
+  { Key_S_Lft   , KK_EditBlockLeft        , KT_E },
+  { Key_S_Rgt   , KK_EditBlockRight       , KT_E },
+#endif
 
   { Key_Esc     , KK_FileAbort            , KT_F },
@@ -313,4 +326,7 @@
   { CRC_READTOGGLEHIDDEN       , KK_ReadToggleHidden     , KT_R }, // 0x04CE
   { CRC_EDITIMPORTTEXT         , KK_EditImportText       , KT_E }, // 0x0586
+#if defined(__MSDOS__) or defined(__OS2__)
+  { CRC_K_SEND                 , Key_S_End               ,    0 }, // 0x0590;
+#endif
   { CRC_READGOTOPREVMSG        , KK_ReadGotoPrevMsg      , KT_R }, // 0x06D9
   { CRC_K_STAB                 , Key_S_Tab               ,    0 }, // 0x0886
@@ -422,4 +438,7 @@
   { CRC_K_ADEL                 , Key_A_Del               ,    0 }, // 0x40C0
   { CRC_NODEMACRO              , KK_NodeMacro            , KT_N }, // 0x4129
+#if defined(__MSDOS__) or defined(__OS2__)
+  { CRC_K_SUP                  , Key_S_Up                ,    0 }, // 0x4151;
+#endif
   { CRC_AREAGOTOFIRST          , KK_AreaGotoFirst        , KT_A }, // 0x41CB
   { CRC_LISTABORT              , KK_ListAbort            , KT_M }, // 0x4313
@@ -476,4 +495,7 @@
   { CRC_EDITLOOKUPORIG         , KK_EditLookupOrig       , KT_E }, // 0x5AFB
   { CRC_AREAHEAT               , KK_AreaHeat             , KT_A }, // 0x5B15
+#if defined(__MSDOS__) or defined(__OS2__)
+  { CRC_K_SRIGHT               , Key_S_Rgt               ,    0 }, // 0x5B1F;
+#endif
   { CRC_READGOTONEXTAREA       , KK_ReadGotoNextArea     , KT_R }, // 0x5B23
   { CRC_K_TAB                  , Key_Tab                 ,    0 }, // 0x5B33
@@ -614,6 +636,12 @@
   { CRC_READQUITNOW            , KK_ReadQuitNow          , KT_R }, // 0xAC15
   { CRC_EDITDELLINE            , KK_EditDelLine          , KT_E }, // 0xACCF
+#if defined(__MSDOS__) or defined(__OS2__)
+  { CRC_K_SPGDN                , Key_S_PgDn              ,    0 }, // 0xAD44;
+#endif
   { CRC_READSOUNDKILL          , KK_ReadSoundkill        , KT_R }, // 0xAE29
   { CRC_LISTUNDEFINE           , KK_ListUndefine         , KT_M }, // 0xAF86
+#if defined(__MSDOS__) or defined(__OS2__)
+  { CRC_K_SHOME                , Key_S_Home              ,    0 }, // 0xAF9D;
+#endif
   { CRC_READTOGGLEQUOTE        , KK_ReadToggleQuote      , KT_R }, // 0xB293
   { CRC_FILETOGGLEMARK         , KK_FileToggleMark       , KT_F }, // 0xB431
@@ -624,4 +652,7 @@
   { CRC_K_CINS                 , Key_C_Ins               ,    0 }, // 0xBA0E
   { CRC_READGOTONEXTUNREAD     , KK_ReadGotoNextUnread   , KT_R }, // 0xBA34
+#if defined(__MSDOS__) or defined(__OS2__)
+  { CRC_K_SPGUP                , Key_S_PgUp              ,    0 }, // 0xBC5A;
+#endif
   { CRC_FILEABORT              , KK_FileAbort            , KT_F }, // 0xBCED
   { CRC_READCHANGETAGLINE      , KK_ReadChangeTagline    , KT_R }, // 0xBDD2
@@ -631,7 +662,13 @@
   { CRC_EDITTOGGLECASE         , KK_EditToggleCase       , KT_E }, // 0xC282
   { CRC_FILEGOTOLAST           , KK_FileGotoLast         , KT_F }, // 0xC40A
+#if defined(__MSDOS__) or defined(__OS2__)
+  { CRC_K_SINS                 , Key_S_Ins               ,    0 }, // 0xC40B;
+#endif
   { CRC_AREASCANPM             , KK_AreaScanPM           , KT_A }, // 0xC4FF
   { CRC_READMSGEND             , KK_ReadMsgEnd           , KT_R }, // 0xC5AD
   { CRC_AREATOGGLE             , KK_AreaToggle           , KT_A }, // 0xC734
+#if defined(__MSDOS__) or defined(__OS2__)
+  { CRC_K_SLEFT                , Key_S_Lft               ,    0 }, // 0xC902;
+#endif
   { CRC_NODEGOTOLAST           , KK_NodeGotoLast         , KT_N }, // 0xCA13
   { CRC_FILEGOTOFIRST          , KK_FileGotoFirst        , KT_F }, // 0xCAD5
@@ -680,4 +717,7 @@
   { CRC_READFINDALL            , KK_ReadFindAll          , KT_R }, // 0xEF19
   { CRC_NODEDOSSHELL           , KK_NodeDosShell         , KT_N }, // 0xF084
+#if defined(__MSDOS__) or defined(__OS2__)
+  { CRC_K_SDOWN                , Key_S_Dwn               ,    0 }, // 0xF0FB;
+#endif
   { CRC_READCHANGEXLATIMPORT   , KK_ReadChangeXlatImport , KT_R }, // 0xF169
   { CRC_READTOGGLESTYLES       , KK_ReadToggleStyles     , KT_R }, // 0xF47E
@@ -933,5 +973,5 @@
           if(*ptr2 == '$') {
             uint _keyval = keyval;
-            sscanf(ptr2, "%4x", &_keyval);
+            sscanf(ptr2+1, "%4x", &_keyval); // gul
             keyval = (Key)_keyval;
           }
diff -u2 -r goldware.2/golded3/gckeys.h goldware/golded3/gckeys.h
--- goldware.2/golded3/gckeys.h	Sat Feb  6 16:00:20 1999
+++ goldware/golded3/gckeys.h	Tue Mar 23 15:03:14 1999
@@ -456,4 +456,16 @@
 const word CRC_KK_AUTO              = 0x60E2;
 
+#if defined(__MSDOS__) or defined(__OS2__)
+const word CRC_K_SINS               = 0xC40B;
+const word CRC_K_SHOME              = 0xAF9D;
+const word CRC_K_SEND               = 0x0590;
+const word CRC_K_SPGUP              = 0xBC5A;
+const word CRC_K_SPGDN              = 0xAD44;
+const word CRC_K_SLEFT              = 0xC902;
+const word CRC_K_SRIGHT             = 0x5B1F;
+const word CRC_K_SUP                = 0x4151;
+const word CRC_K_SDOWN              = 0xF0FB;
+#endif
+
 
 //  ------------------------------------------------------------------
diff -u2 -r goldware.2/golded3/geedit.cpp goldware/golded3/geedit.cpp
--- goldware.2/golded3/geedit.cpp	Sat Nov 21 21:38:02 1998
+++ goldware/golded3/geedit.cpp	Tue Mar 23 15:13:10 1999
@@ -284,5 +284,5 @@
 void stylecode_prints(int wrow, int wcol, int atr, char* str) { _editor->editwin.prints(wrow,wcol,atr,str); }
 
-void IEclass::dispstring(char* __string, uint __row, int attr) {
+void IEclass::dispstring(char* __string, uint __row, int attr, Line* line) {
 
   GFTRK("Editdispstring");
@@ -326,7 +326,39 @@
 
   // Print the string
-  editwin.prints(__row, mincol, attr, _buf);
-  if(CFG->switches.get(stylecodes))
-    StyleCodeHighlight(__string, __row, mincol, false, attr, (VidPutStrCP)stylecode_prints);
+  // mark selected block
+  if(line and (blockcol != -1)) {
+    int selected = 0;
+    for(Line *ln = findfirstline(); ln and ln != line; ln = ln->next) {
+      if(ln == currline)
+        selected ^= 1;
+      if(ln->type & GLINE_BLOK)
+        selected ^= 1;
+    }
+    if((line->type & GLINE_BLOK) and (line == currline)) {
+      int begblock = (col < blockcol) ? col : blockcol;
+      int endblock = (col > blockcol) ? col : blockcol;
+      char savechar = _buf[begblock];
+      _buf[begblock] = NUL;
+      StyleCodeHighlight(_buf, __row, mincol, false, attr, (VidPutStrCP)stylecode_prints);
+      _buf[begblock] = savechar;
+      savechar = _buf[endblock];
+      _buf[endblock] = NUL;
+      StyleCodeHighlight(_buf+begblock, __row, mincol+begblock, false, C_READA, (VidPutStrCP)stylecode_prints);
+      _buf[endblock] = savechar;
+      StyleCodeHighlight(_buf+endblock, __row, mincol+endblock, false, attr, (VidPutStrCP)stylecode_prints);
+    }
+    else if((line->type & GLINE_BLOK) or (line == currline)) {
+      int blockmark = (line->type & GLINE_BLOK) ? blockcol : col;
+      char savechar = _buf[blockmark];
+      _buf[blockmark] = NUL;
+      StyleCodeHighlight(_buf, __row, mincol, false, selected ? C_READA : attr, (VidPutStrCP)stylecode_prints);
+      _buf[blockmark] = savechar;
+      StyleCodeHighlight(_buf+blockmark, __row, mincol+blockmark, false, selected ? attr : C_READA, (VidPutStrCP)stylecode_prints);
+    }
+    else
+      StyleCodeHighlight(_buf, __row, mincol, false, selected ? C_READA : attr, (VidPutStrCP)stylecode_prints);
+  }
+  else
+    StyleCodeHighlight(_buf, __row, mincol, false, attr, (VidPutStrCP)stylecode_prints);
 
   GFTRK(NULL);
@@ -339,7 +371,5 @@
 
   // Set window attribute
-  if(__line->type & GLINE_BLOK)
-    editwin.text_color(C_READA);
-  else if(__line->type & GLINE_HIDD)
+  if(__line->type & GLINE_HIDD)
     editwin.text_color(C_READK);
   else if(__line->type & GLINE_KLUD)
@@ -374,5 +404,5 @@
   // Display line
   setcolor(__line);
-  dispstring(__line->text, __row);
+  dispstring(__line->text, __row, -1, __line);
 
   GFTRK(NULL);
@@ -438,8 +468,8 @@
 
   Line* _nextline = (Line*)throw_xcalloc(1, sizeof(Line));
+  _nextline->text = __text ? throw_strdup(__text) : (char*)NULL;
 
   if(__currline) {
 
-    _nextline->text = __text ? throw_strdup(__text) : (char*)NULL;
     _nextline->prev = __currline;
     _nextline->next = __currline->next;
@@ -506,4 +536,7 @@
   _test_haltab(col > maxcol, col, maxcol);
 
+  if(blockcol != -1)
+    displine(currline, row);
+
   GFTRK(NULL);
 }
@@ -525,8 +558,14 @@
     if(row == minrow) {
       scrolldown(mincol, row, maxcol, maxrow);
+      if(blockcol != -1)
+        displine(currline->next, row+1);
       displine(currline, row);
     }
     else {
       row--;
+      if(blockcol != -1) {
+        displine(currline->next, row+1);
+        displine(currline, row);
+      }
     }
 
@@ -554,8 +593,14 @@
     if(row == maxrow) {
       scrollup(mincol, minrow, maxcol, maxrow);
+      if(blockcol != -1)
+        displine(currline->prev, row-1);
       displine(currline,row);
     }
     else {
       row++;
+      if(blockcol != -1) {
+        displine(currline->prev, row-1);
+        displine(currline, row);
+      }
     }
 
@@ -581,8 +626,11 @@
       GoEOL();
     }
-    col++;  // reverse of col-- below...
+    GFTRK(NULL);
+    return;
   }
 
   col--;
+  if(blockcol != -1)
+    displine(currline, row);
 
   GFTRK(NULL);
@@ -605,8 +653,11 @@
       col = mincol;
     }
-    col--;  // reverse of col++ below
+    GFTRK(NULL);
+    return;
   }
 
   col++;
+  if(blockcol != -1)
+    displine(currline, row);
 
   GFTRK(NULL);
@@ -1153,4 +1204,7 @@
     col++;
 
+  if(blockcol != -1)
+    displine(currline, row);
+
   GFTRK(NULL);
 }
@@ -1196,4 +1250,7 @@
   }
 
+  if(blockcol != -1)
+    displine(currline, row);
+
   GFTRK(NULL);
 }
@@ -1299,5 +1356,5 @@
   _nextline = insertlinebelow(currline);
   _nextline->text   = throw_strdup(currline->text);
-  _nextline->type   = currline->type;
+  _nextline->type   = currline->type & ~GLINE_BLOK;
   _nextline->color  = currline->color;
   _nextline->kludge = currline->kludge;
@@ -1342,4 +1399,6 @@
       row = minrow;
       currline = _topline;
+      if(blockcol != -1)
+        refresh(currline, row);
     }
     else {
@@ -1354,7 +1413,4 @@
       }
 
-      // Refresh display
-      refresh(_topline, minrow);
-
       // Set the current line
       _count = row;
@@ -1362,4 +1418,7 @@
       while(_count--)
         currline = currline->next;
+
+      // Refresh display
+      refresh(_topline, minrow);
     }
   }
@@ -1393,5 +1452,6 @@
 
     // Go down to the last displayed line in the window
-    uint _newrow = row;
+    uint _newrow = row, _oldrow = row;
+    Line *oldcurrline = currline;
     while((_newrow < maxrow) AND currline->next) {
       currline = currline->next;
@@ -1401,5 +1461,5 @@
     // If there are more lines after the last line, start displaying from the top
     if(currline->next) {
-      refresh(currline, minrow);
+      Line *_topline = currline;
 
       // Set current line
@@ -1413,7 +1473,10 @@
       if(_newrow < row)
         row = _newrow;
+
+      refresh(_topline, minrow);
     }
     else {
       row = _newrow;
+      refresh(oldcurrline, _oldrow);
     }
   }
@@ -1534,4 +1597,9 @@
       _prevline->next = currline;
 
+    if(_deletedline->type & GLINE_BLOK) {
+      blockcol = -1;
+      _deletedline->type &= ~GLINE_BLOK;
+    }
+
     // Link the deleted line to the killbuffer
     if(Edit__killbuf) {
@@ -1970,4 +2038,48 @@
 
   switch(__key) {
+    case KK_EditBlockRight:  __key = KK_EditGoRight;   break;
+    case KK_EditBlockLeft:   __key = KK_EditGoLeft;    break;
+    case KK_EditBlockUp:     __key = KK_EditGoUp;      break;
+    case KK_EditBlockDown:   __key = KK_EditGoDown;    break;
+    case KK_EditBlockHome:   __key = KK_EditGoBegLine; break;
+    case KK_EditBlockEnd:    __key = KK_EditGoEOL;     break;
+    case KK_EditBlockPgDn:   __key = KK_EditGoPgDn;    break;
+    case KK_EditBlockPgUp:   __key = KK_EditGoPgUp;    break;
+
+    case KK_EditCopy:
+    case KK_EditCut:         goto noselecting;
+    default:
+      if(selecting) {
+        Line *_line;
+        selecting = NO;
+        blockcol = -1;
+        for(_line = findfirstline(); _line; _line = _line->next)
+          _line->type &= ~GLINE_BLOK;
+        // refresh screen
+        int r = row;
+        for(_line = currline; _line and r; _line = _line->prev)
+          r--;
+        refresh(_line, minrow);
+      }
+      goto noselecting;
+  }
+
+  if(not selecting) {
+    Line *_line;
+    for(_line = findfirstline(); _line; _line = _line->next)
+      _line->type &= ~GLINE_BLOK;
+    currline->type |= GLINE_BLOK;
+    selecting = YES;
+    blockcol = col;
+    // refresh screen
+    int r = row;
+    for(_line = currline; _line and r; _line = _line->prev)
+      r--;
+    refresh(_line, minrow);
+  }
+
+noselecting:
+
+  switch(__key) {
     case KK_EditAbort:            Abort();              break;
     case KK_EditAskExit:          AskExit();            break;
@@ -2122,6 +2234,9 @@
     gotorowcol(col, row);
 
-    int backattr = dispchar(currline->text[col], C_READC);
-    gotorowcol(col, row);
+    int backattr;
+    if(blockcol == -1) {
+      backattr = dispchar(currline->text[col], C_READC);
+      gotorowcol(col, row);
+    }
 
     cursoron();
@@ -2158,5 +2273,6 @@
     }
 
-    dispchar(currline->text[col], backattr);
+    if(blockcol == -1)
+      dispchar(currline->text[col], backattr);
 
     chartyped = FALSE;
diff -u2 -r goldware.2/golded3/geedit.h goldware/golded3/geedit.h
--- goldware.2/golded3/geedit.h	Sat Nov 21 21:38:02 1998
+++ goldware/golded3/geedit.h	Tue Mar 23 14:52:42 1999
@@ -141,4 +141,6 @@
   uint  thisrow;
   char*  unfinished;
+  int  blockcol;
+  int  selecting;
 
 
@@ -153,5 +155,5 @@
   void  dispins         ();
   void  displine        (Line* __line, uint __row);
-  void  dispstring      (char* __string, uint __row, int attr=-1);
+  void  dispstring      (char* __string, uint __row, int attr=-1, Line* line = NULL);
   int  downoneline     (uint __row);
   void  export          (Line* __exportline, int __endat);
@@ -187,4 +189,9 @@
   #ifndef NDEBUG
   void  debugtest       (char* __test, int __a, int __b, char* __file, int __line, int __values);
+  #endif
+
+  #ifdef __OS2__
+  void Buf2Clip       ();
+  void Clip2Buf       ();
   #endif
 
diff -u2 -r goldware.2/golded3/geedit2.cpp goldware/golded3/geedit2.cpp
--- goldware.2/golded3/geedit2.cpp	Sat Nov 21 21:38:02 1998
+++ goldware/golded3/geedit2.cpp	Tue Mar 23 15:18:34 1999
@@ -69,4 +69,6 @@
   thisrow      = 0;
   unfinished   = "+$!$+ GoldED Internal Editor: Unfinished Message!";
+  blockcol     = -1;
+  selecting    = NO;
 
   windowopen();
@@ -311,8 +313,8 @@
 
   currline = findfirstline();
-  refresh(currline, minrow);
   col = mincol;
   row = minrow;
   thisrow = 0;
+  refresh(currline, minrow);
 
   GFTRK(NULL);
@@ -372,4 +374,7 @@
   row = minrow;
 
+  if(blockcol != -1)
+    refresh(currline, minrow);
+
   GFTRK(NULL);
 }
@@ -382,4 +387,7 @@
   GFTRK("EditGoBotLine");
 
+  Line *_oldcurrline = currline;
+  int  _oldrow = row;
+  
   while((row < maxrow) AND currline->next) {
     currline = currline->next;
@@ -390,4 +398,7 @@
   col = mincol;
 
+  if(blockcol != -1)
+    refresh(_oldcurrline, _oldrow);
+
   GFTRK(NULL);
 }
@@ -429,4 +440,5 @@
     // Remove block mark
     _anchor->type &= ~GLINE_BLOK;
+    blockcol = -1;
 
     // Is the old anchor different from the current line?
@@ -436,4 +448,5 @@
       _anchor = currline;
       _anchor->type |= GLINE_BLOK;
+      blockcol = col;
 
       // Find the line at the top
@@ -452,4 +465,5 @@
     // There was no anchor, so mark the current line as the new anchor
     currline->type |= GLINE_BLOK;
+    blockcol = col;
   }
 
@@ -474,4 +488,5 @@
     Line* _firstcopyline = currline;
     Line* _lastcopyline  = currline;
+    int   firstcol = col, lastcol = col;
 
     // Search below to find the anchor line
@@ -488,4 +503,11 @@
       while(_firstcopyline->prev AND (_firstcopyline != _anchor))
         _firstcopyline = _firstcopyline->prev;
+      firstcol = blockcol;
+    }
+    else {
+      if(currline != _anchor or blockcol > col)
+        lastcol = blockcol;
+      else
+        firstcol = blockcol;
     }
 
@@ -501,11 +523,23 @@
     // Copy lines to the paste buffer
     while(1) {
+      Line* _copyline;
 
       // Allocate a new line
-      Line* _copyline = (Line*)throw_xcalloc(1, sizeof(Line));
+      _copyline = (Line*)throw_xmalloc(sizeof(Line));
 
       // Copy text and type
-      _copyline->text = throw_strdup(_firstcopyline->text);
-      _copyline->type = _firstcopyline->type;
+      if(_prevline == NULL)
+        _copyline->text = throw_strdup(_firstcopyline->text + firstcol);
+      else
+        _copyline->text = throw_strdup(_firstcopyline->text);
+      if(_firstcopyline == _lastcopyline) {
+        if(_prevline)
+          _copyline->text[lastcol] = NUL;
+        else
+          _copyline->text[lastcol-firstcol] = NUL;
+      }
+      _copyline->type = _firstcopyline->type & ~GLINE_BLOK;
+      if(_prevline == NULL or _firstcopyline == _lastcopyline)
+        setlinetype(_copyline);
 
       // Link in the new line
@@ -513,4 +547,5 @@
       if(_prevline)
         _prevline->next = _copyline;
+      _copyline->next = NULL;
 
       // Point the paste buffer to the first line of the copy
@@ -528,4 +563,10 @@
       _firstcopyline = _firstcopyline->next;
     } 
+
+#ifdef __OS2__
+    Buf2Clip();
+    killpastebuf();
+#endif
+
   }
 
@@ -546,9 +587,11 @@
   if(_anchor) {
 
+    BlockCopy();
+
     Line* _firstcutline = currline;
     Line* _lastcutline  = currline;
     uint _firstcutlinerow = row;
     uint _lastcutlinerow  = row;
-    //int _currrow = row;
+    int  _firstcol = col, _lastcol = col;
 
     // Search below to find the anchor line
@@ -571,4 +614,11 @@
           _firstcutlinerow--;
       }
+      _firstcol = blockcol;
+    }
+    else {
+      if(currline != _anchor or blockcol > col)
+        _lastcol = blockcol;
+      else
+        _firstcol = blockcol;
     }
 
@@ -576,55 +626,42 @@
     // are now pointing where they should
 
-    // Is the first cut line NOT the first line in the msg?
-    if(_firstcutline->prev) {
-
-      // Link the previous line of the first cut line
-      // to the next line of the last cut line
+    char *newtext = (char *)throw_malloc(_firstcol+strlen(_lastcutline->text)-_lastcol+1);
+    strxcpy(newtext, _firstcutline->text, _firstcol+1);
+    strcat(newtext, _lastcutline->text+_lastcol);
+    throw_free(_firstcutline->text);
+    _firstcutline->text = newtext;
+    setlinetype(_firstcutline);
+    _firstcutline->type &= ~GLINE_BLOK;
+    blockcol = -1;
+    currline = _firstcutline;
+    row = _firstcutlinerow;
+    col = _firstcol;
+    if(_firstcutline != _lastcutline) {
+      _firstcutline = _firstcutline->next;
       _firstcutline->prev->next = _lastcutline->next;
+      if(_lastcutline->next)
+        _lastcutline->next->prev = _firstcutline->prev;
+      _lastcutline->next = NULL;
+
+      // free deleted lines
+      while(_firstcutline) {
+        throw_free(_firstcutline->text);
+        Line *oldline = _firstcutline;
+        _firstcutline = _firstcutline->next;
+        throw_xfree(oldline);
+      }
     }
 
-    // If there is a next line for the last cut line
-    if(_lastcutline->next) {
-
-      // Set the current line to it
-      currline = _lastcutline->next;
-      row = _lastcutlinerow + 1;
-
-      // Link the next line of the last cut line
-      // to the previous line of the first cut line
-      _lastcutline->next->prev = _firstcutline->prev;
-    }
-    else {
-
-      // Set the current line to the previous line for the first cut line
-      currline = _firstcutline->prev;
-      row = _firstcutlinerow - 1;
-    }
-
-    // Remove the previous/next links from the cut lines
-    _firstcutline->prev = _lastcutline->next = NULL;
-
-    // If the current line was lost, allocate a blank one
-    if(currline == NULL) {
-      currline = (Line*)throw_xcalloc(1, sizeof(Line));
-      currline->text = throw_strdup("\n");
-      row = 0;
-    }
-
-    // Remove the old paste buffer and point to the new cut
-    killpastebuf();
-    Edit__pastebuf = _firstcutline;
-
     // Refresh the display
     if(NOT RngV(row, minrow, maxrow)) {
       row = minrow;
-      refresh(currline, minrow);
+      wrapdel(&currline, &col, &row, YES);
     }
     else {
       row = MaxV(_firstcutlinerow, minrow);
       Line* _topline = findtopline();
+      wrapdel(&currline, &col, &row, NO);
       refresh(_topline, minrow);
     }
-    col = mincol;
   }
 
@@ -639,7 +676,11 @@
   GFTRK("EditBlockPaste");
 
+#ifdef __OS2__
+  killpastebuf();
+  Clip2Buf();
+#endif
+
   if(Edit__pastebuf) {
 
-    Line* _newcurrline = NULL;
     Line* _pasteline   = Edit__pastebuf;
     Line* _prevline    = currline->prev;
@@ -648,24 +689,56 @@
     while(_pasteline) {
 
-      // Allocate a new line
-      Line* _templine = (Line*)throw_xcalloc(1, sizeof(Line));
+      char *newtext = NULL;
 
-      // Set the new current line to the first pasted line
-      if(_newcurrline == NULL)
-        _newcurrline = _templine;
-
-      // Link in the pasted line
-      currline->prev = _templine;
-      _templine->next = currline;
-      _templine->prev = _prevline;
-      if(_prevline)
+      if(col > strlen(currline->text))
+        col = strlen(currline->text);
+
+      if(strchr(_pasteline->text, '\n') == NULL) {
+        // insert into current line
+        newtext = (char *)throw_malloc(strlen(_pasteline->text) + strlen(currline->text) + 1);
+        strxcpy(newtext, currline->text, col+1);
+        strcpy(newtext+col, _pasteline->text);
+        strcat(newtext, currline->text + col);
+        throw_free(currline->text);
+        currline->text = newtext;
+        col += strlen(_pasteline->text);
+        wrapins(&currline, &col, &row, NO);
+      }
+      else {
+        // append to current line
+        char *oldtext = (char *)throw_malloc(col + strlen(_pasteline->text) + 1);
+        newtext = (char *)throw_malloc(strlen(currline->text)-col+1);
+        strxcpy(oldtext, currline->text, col+1);
+        strcpy(oldtext+col, _pasteline->text);
+        strcpy(newtext, currline->text + col);
+        throw_free(currline->text);
+        currline->text = oldtext;
+        col = 0;
+        _prevline = currline;
+        setlinetype(currline);
+        currline = currline->next;
+
+        // Allocate a new line
+        Line* _templine = (Line*)throw_xmalloc(sizeof(Line));
+
+        // Link in the pasted line
+        if(currline)
+          currline->prev = _templine;
+        _templine->next = currline;
+        _templine->prev = _prevline;
         _prevline->next = _templine;
+        currline = _templine;
+
+        // Duplicate the text of the pasted line
+        _templine->text = newtext;
 
-      // Duplicate the text and type of the pasted line
-      _templine->text = throw_strdup(_pasteline->text);
-      _templine->type = _pasteline->type & ~GLINE_BLOK;
+        col = strlen(_prevline->text);
+        wrapins(&_prevline, &col, &row, NO);
+        col = 0;
+        if(row < maxrow)
+          row++;
+      }
 
-      // Store pointer to the new pasted line
-      _prevline = _templine;
+      setlinetype(currline);
 
       // Continue with the next line in the paste buffer
@@ -673,12 +746,7 @@
     }
 
-    // Set the new current line
-    if(_newcurrline)
-      currline = _newcurrline;
-
     // Refresh the display
     Line* _topline = findtopline();
     refresh(_topline, minrow);
-    col = mincol;
   }
 
diff -u2 -r goldware.2/golded3/geglob.cpp goldware/golded3/geglob.cpp
--- goldware.2/golded3/geglob.cpp	Sat Nov 21 21:38:02 1998
+++ goldware/golded3/geglob.cpp	Tue Mar 23 15:19:32 1999
@@ -469,4 +469,9 @@
   char* stylestopchars = CFG->stylecodestops;
   char prevchar = ' ';
+
+  if(!CFG->switches.get(stylecodes)) {
+    (*fp)(row, col, color, text);
+    return;
+  }
   while(*ptr) {
     if(isstylechar(*ptr)) {
@@ -526,8 +531,11 @@
                   }
                   else {
+                    strxcpy(buf, text+txlen, (uint)(beginstyle-text-txlen)+1);
+                    (*fp)(row, col+sclen, color, buf);
+                    sclen += strlen(buf);
                     strxcpy(buf, beginstyle, (uint)(endstyle-beginstyle)+2);
+                    (*fp)(row, col+(uint)(beginstyle-text), C_STYLE[colorindex], buf);
                     sclen += strlen(buf);
                     txlen = sclen;
-                    (*fp)(row, col+(uint)(beginstyle-text), C_STYLE[colorindex], buf);
                   }
                 }
@@ -543,12 +551,10 @@
       prevchar = *ptr++;
   }
-  if(dohide) {
-    strxcpy(buf, text+txlen, strlen(text+txlen)+1);
-    (*fp)(row, col+sclen, color, buf);
-    sclen += strlen(buf);
-    txlen = strlen(text) - sclen;
-    memset(buf, ' ', txlen);buf[txlen] = NUL;
-    (*fp)(row, col+sclen, color, buf);
-  }
+  strxcpy(buf, text+txlen, strlen(text+txlen)+1);
+  (*fp)(row, col+sclen, color, buf);
+  sclen += strlen(buf);
+  txlen = strlen(text) - sclen;
+  memset(buf, ' ', txlen);buf[txlen] = NUL;
+  (*fp)(row, col+sclen, color, buf);
 }
 
diff -u2 -r goldware.2/golded3/gekeys.h goldware/golded3/gekeys.h
--- goldware.2/golded3/gekeys.h	Sat Feb  6 16:00:20 1999
+++ goldware/golded3/gekeys.h	Tue Mar 23 08:16:54 1999
@@ -164,143 +164,151 @@
 const Key KK_EditUnDelete         = 0xFEF9;
 const Key KK_EditZapQuoteBelow    = 0xFEFA;
+const Key KK_EditBlockRight       = 0xFEFB;
+const Key KK_EditBlockLeft        = 0xFEFC;
+const Key KK_EditBlockUp          = 0xFEFD;
+const Key KK_EditBlockDown        = 0xFEFE;
+const Key KK_EditBlockHome        = 0xFEFF;
+const Key KK_EditBlockEnd         = 0xFF00;
+const Key KK_EditBlockPgDn        = 0xFF01;
+const Key KK_EditBlockPgUp        = 0xFF02;
+
+const Key KK_FileAbort            = 0xFF10;
+const Key KK_FileAskExit          = 0xFF11;
+const Key KK_FileDosShell         = 0xFF12;
+const Key KK_FileGotoFirst        = 0xFF13;
+const Key KK_FileGotoLast         = 0xFF14;
+const Key KK_FileGotoNext         = 0xFF15;
+const Key KK_FileGotoPrev         = 0xFF16;
+const Key KK_FileMark             = 0xFF17;
+const Key KK_FileMarkAll          = 0xFF18;
+const Key KK_FileMenu             = 0xFF19;
+const Key KK_FileQuitNow          = 0xFF1A;
+const Key KK_FileSelect           = 0xFF1B;
+const Key KK_FileToggleMark       = 0xFF1C;
+const Key KK_FileToggleMarkAll    = 0xFF1D;
+const Key KK_FileUnMark           = 0xFF1E;
+const Key KK_FileUnMarkAll        = 0xFF1F;
+
+const Key KK_ListAbort            = 0xFF20;
+const Key KK_ListAskExit          = 0xFF21;
+const Key KK_ListDosShell         = 0xFF22;
+const Key KK_ListGotoBookMark     = 0xFF23;
+const Key KK_ListGotoFirst        = 0xFF24;
+const Key KK_ListGotoLast         = 0xFF25;
+const Key KK_ListGotoNext         = 0xFF26;
+const Key KK_ListGotoPrev         = 0xFF27;
+const Key KK_ListMainMenu         = 0xFF28;
+const Key KK_ListMarkingOptions   = 0xFF29;
+const Key KK_ListMenu             = 0xFF2A;
+const Key KK_ListQuitNow          = 0xFF2B;
+const Key KK_ListSelect           = 0xFF2C;
+const Key KK_ListToggleBookMark   = 0xFF2D;
+const Key KK_ListToggleDate       = 0xFF2E;
+const Key KK_ListToggleMark       = 0xFF2F;
+const Key KK_ListToggleWideSubj   = 0xFF30;
+
+const Key KK_NodeAbort            = 0xFF40;
+const Key KK_NodeAskExit          = 0xFF41;
+const Key KK_NodeDosShell         = 0xFF42;
+const Key KK_NodeGotoFirst        = 0xFF43;
+const Key KK_NodeGotoLast         = 0xFF44;
+const Key KK_NodeGotoNext         = 0xFF45;
+const Key KK_NodeGotoPrev         = 0xFF46;
+const Key KK_NodeMainMenu         = 0xFF47;
+const Key KK_NodeMenu             = 0xFF48;
+const Key KK_NodeQuitNow          = 0xFF49;
+const Key KK_NodeSelect           = 0xFF4A;
+
+const Key KK_ReadAddressbookAdd   = 0xFF50;
+const Key KK_ReadAskExit          = 0xFF51;
+const Key KK_ReadChangeAka        = 0xFF52;
+const Key KK_ReadChangeAttrs      = 0xFF53;
+const Key KK_ReadChangeCharsIn    = 0xFF54;
+const Key KK_ReadChangeCharsOut   = 0xFF55;
+const Key KK_ReadChangeMsg        = 0xFF56;
+const Key KK_ReadChangeOrigin     = 0xFF57;
+const Key KK_ReadChangeTagline    = 0xFF58;
+const Key KK_ReadChangeTemplate   = 0xFF59;
+const Key KK_ReadChangeUsername   = 0xFF5A;
+const Key KK_ReadChangeXlatImport = 0xFF5B;
+const Key KK_ReadCommentMsg       = 0xFF5C;
+const Key KK_ReadCopyMoveForward  = 0xFF5D;
+const Key KK_ReadDecreaseMargin   = 0xFF5E;
+const Key KK_ReadDeleteMsg        = 0xFF5F;
+const Key KK_ReadDosShell         = 0xFF60;
+const Key KK_ReadExternUtilMenu   = 0xFF61;
+const Key KK_ReadFidoRenumber     = 0xFF62;
+const Key KK_ReadFileRequest      = 0xFF63;
+const Key KK_ReadFindAll          = 0xFF64;
+const Key KK_ReadFindHeader       = 0xFF65;
+const Key KK_ReadGotoBookMark     = 0xFF66;
+const Key KK_ReadGotoFirstMsg     = 0xFF67;
+const Key KK_ReadGotoLastMsg      = 0xFF68;
+const Key KK_ReadGotoMsgno        = 0xFF69;
+const Key KK_ReadGotoNextArea     = 0xFF6A;
+const Key KK_ReadGotoNextMsg      = 0xFF6B;
+const Key KK_ReadGotoNextUnread   = 0xFF6C;
+const Key KK_ReadGotoPrevArea     = 0xFF6D;
+const Key KK_ReadGotoPrevMsg      = 0xFF6E;
+const Key KK_ReadGotoPrevUnread   = 0xFF6F;
+const Key KK_ReadGotoReplies      = 0xFF70;
+const Key KK_ReadGotoReply1st     = 0xFF71;
+const Key KK_ReadGotoReplyNext    = 0xFF72;
+const Key KK_ReadGotoReplyPrev    = 0xFF73;
+const Key KK_ReadIncreaseMargin   = 0xFF74;
+const Key KK_ReadLookupDest       = 0xFF75;
+const Key KK_ReadLookupOrig       = 0xFF76;
+const Key KK_ReadMainMenu         = 0xFF77;
+const Key KK_ReadMakeUserlist     = 0xFF78;
+const Key KK_ReadMarkingOptions   = 0xFF79;
+const Key KK_ReadMenu             = 0xFF7A;
+const Key KK_ReadMessageList      = 0xFF7B;
+const Key KK_ReadMakePathreport   = 0xFF7C;
+const Key KK_ReadMoveCommentMsg   = 0xFF7D;
+const Key KK_ReadMoveQuoteMsg     = 0xFF7E;
+const Key KK_ReadMsgContinue      = 0xFF7F;
+const Key KK_ReadMsgEnd           = 0xFF80;
+const Key KK_ReadMsgHome          = 0xFF81;
+const Key KK_ReadMsgLineDown      = 0xFF82;
+const Key KK_ReadMsgLineUp        = 0xFF83;
+const Key KK_ReadMsgPgDn          = 0xFF84;
+const Key KK_ReadMsgPgUp          = 0xFF85;
+const Key KK_ReadNewArea          = 0xFF86;
+const Key KK_ReadNewMsg           = 0xFF87;
+const Key KK_ReadQuitNow          = 0xFF88;
+const Key KK_ReadQuoteBuf         = 0xFF89;
+const Key KK_ReadQuoteMsg         = 0xFF8A;
+const Key KK_ReadReplyMsg         = 0xFF8B;
+const Key KK_ReadSearch           = 0xFF8C;
+const Key KK_ReadSoundkill        = 0xFF8D;
+const Key KK_ReadStealTagline     = 0xFF8E;
+const Key KK_ReadThreadtree       = 0xFF8F;
+const Key KK_ReadToggleBookMark   = 0xFF90;
+const Key KK_ReadToggleHexdump    = 0xFF91;
+const Key KK_ReadToggleHidden     = 0xFF92;
+const Key KK_ReadToggleHiddKlud   = 0xFF93;
+const Key KK_ReadToggleKludge     = 0xFF94;
+const Key KK_ReadToggleMark       = 0xFF95;
+const Key KK_ReadToggleMarkRead   = 0xFF96;
+const Key KK_ReadTogglePageBar    = 0xFF97;
+const Key KK_ReadToggleQuote      = 0xFF98;
+const Key KK_ReadToggleRealMsgno  = 0xFF99;
+const Key KK_ReadToggleROT13      = 0xFF9A;
+const Key KK_ReadToggleStyles     = 0xFF9B;
+const Key KK_ReadToggleTwits      = 0xFF9C;
+const Key KK_ReadTouchNetscan     = 0xFF9D;
+const Key KK_ReadTouchSemaphore   = 0xFF9E;
+const Key KK_ReadUserbase         = 0xFF9F;
+const Key KK_ReadUUDecode         = 0xFFA0;
+const Key KK_ReadWriteMsg         = 0xFFA1;
+
+const Key KK_AreaUndefine         = 0xFFB0;
+const Key KK_EditUndefine         = 0xFFB1;
+const Key KK_FileUndefine         = 0xFFB2;
+const Key KK_ListUndefine         = 0xFFB3;
+const Key KK_NodeUndefine         = 0xFFB4;
+const Key KK_ReadUndefine         = 0xFFB5;
 
-const Key KK_FileAbort            = 0xFF00;
-const Key KK_FileAskExit          = 0xFF01;
-const Key KK_FileDosShell         = 0xFF02;
-const Key KK_FileGotoFirst        = 0xFF03;
-const Key KK_FileGotoLast         = 0xFF04;
-const Key KK_FileGotoNext         = 0xFF05;
-const Key KK_FileGotoPrev         = 0xFF06;
-const Key KK_FileMark             = 0xFF07;
-const Key KK_FileMarkAll          = 0xFF08;
-const Key KK_FileMenu             = 0xFF09;
-const Key KK_FileQuitNow          = 0xFF0A;
-const Key KK_FileSelect           = 0xFF0B;
-const Key KK_FileToggleMark       = 0xFF0C;
-const Key KK_FileToggleMarkAll    = 0xFF0D;
-const Key KK_FileUnMark           = 0xFF0E;
-const Key KK_FileUnMarkAll        = 0xFF0F;
-
-const Key KK_ListAbort            = 0xFF10;
-const Key KK_ListAskExit          = 0xFF11;
-const Key KK_ListDosShell         = 0xFF12;
-const Key KK_ListGotoBookMark     = 0xFF13;
-const Key KK_ListGotoFirst        = 0xFF14;
-const Key KK_ListGotoLast         = 0xFF15;
-const Key KK_ListGotoNext         = 0xFF16;
-const Key KK_ListGotoPrev         = 0xFF17;
-const Key KK_ListMainMenu         = 0xFF18;
-const Key KK_ListMarkingOptions   = 0xFF19;
-const Key KK_ListMenu             = 0xFF1A;
-const Key KK_ListQuitNow          = 0xFF1B;
-const Key KK_ListSelect           = 0xFF1C;
-const Key KK_ListToggleBookMark   = 0xFF1D;
-const Key KK_ListToggleDate       = 0xFF1E;
-const Key KK_ListToggleMark       = 0xFF1F;
-const Key KK_ListToggleWideSubj   = 0xFF20;
-
-const Key KK_NodeAbort            = 0xFF30;
-const Key KK_NodeAskExit          = 0xFF31;
-const Key KK_NodeDosShell         = 0xFF32;
-const Key KK_NodeGotoFirst        = 0xFF33;
-const Key KK_NodeGotoLast         = 0xFF34;
-const Key KK_NodeGotoNext         = 0xFF35;
-const Key KK_NodeGotoPrev         = 0xFF36;
-const Key KK_NodeMainMenu         = 0xFF37;
-const Key KK_NodeMenu             = 0xFF38;
-const Key KK_NodeQuitNow          = 0xFF39;
-const Key KK_NodeSelect           = 0xFF3A;
-
-const Key KK_ReadAddressbookAdd   = 0xFF40;
-const Key KK_ReadAskExit          = 0xFF41;
-const Key KK_ReadChangeAka        = 0xFF42;
-const Key KK_ReadChangeAttrs      = 0xFF43;
-const Key KK_ReadChangeCharsIn    = 0xFF44;
-const Key KK_ReadChangeCharsOut   = 0xFF45;
-const Key KK_ReadChangeMsg        = 0xFF46;
-const Key KK_ReadChangeOrigin     = 0xFF47;
-const Key KK_ReadChangeTagline    = 0xFF48;
-const Key KK_ReadChangeTemplate   = 0xFF49;
-const Key KK_ReadChangeUsername   = 0xFF4A;
-const Key KK_ReadChangeXlatImport = 0xFF4B;
-const Key KK_ReadCommentMsg       = 0xFF4C;
-const Key KK_ReadCopyMoveForward  = 0xFF4D;
-const Key KK_ReadDecreaseMargin   = 0xFF4E;
-const Key KK_ReadDeleteMsg        = 0xFF4F;
-const Key KK_ReadDosShell         = 0xFF50;
-const Key KK_ReadExternUtilMenu   = 0xFF51;
-const Key KK_ReadFidoRenumber     = 0xFF52;
-const Key KK_ReadFileRequest      = 0xFF53;
-const Key KK_ReadFindAll          = 0xFF54;
-const Key KK_ReadFindHeader       = 0xFF55;
-const Key KK_ReadGotoBookMark     = 0xFF56;
-const Key KK_ReadGotoFirstMsg     = 0xFF57;
-const Key KK_ReadGotoLastMsg      = 0xFF58;
-const Key KK_ReadGotoMsgno        = 0xFF59;
-const Key KK_ReadGotoNextArea     = 0xFF5A;
-const Key KK_ReadGotoNextMsg      = 0xFF5B;
-const Key KK_ReadGotoNextUnread   = 0xFF5C;
-const Key KK_ReadGotoPrevArea     = 0xFF5D;
-const Key KK_ReadGotoPrevMsg      = 0xFF5E;
-const Key KK_ReadGotoPrevUnread   = 0xFF5F;
-const Key KK_ReadGotoReplies      = 0xFF60;
-const Key KK_ReadGotoReply1st     = 0xFF61;
-const Key KK_ReadGotoReplyNext    = 0xFF62;
-const Key KK_ReadGotoReplyPrev    = 0xFF63;
-const Key KK_ReadIncreaseMargin   = 0xFF64;
-const Key KK_ReadLookupDest       = 0xFF65;
-const Key KK_ReadLookupOrig       = 0xFF66;
-const Key KK_ReadMainMenu         = 0xFF67;
-const Key KK_ReadMakeUserlist     = 0xFF68;
-const Key KK_ReadMarkingOptions   = 0xFF69;
-const Key KK_ReadMenu             = 0xFF6A;
-const Key KK_ReadMessageList      = 0xFF6B;
-const Key KK_ReadMakePathreport   = 0xFF6C;
-const Key KK_ReadMoveCommentMsg   = 0xFF6D;
-const Key KK_ReadMoveQuoteMsg     = 0xFF6E;
-const Key KK_ReadMsgContinue      = 0xFF6F;
-const Key KK_ReadMsgEnd           = 0xFF70;
-const Key KK_ReadMsgHome          = 0xFF71;
-const Key KK_ReadMsgLineDown      = 0xFF72;
-const Key KK_ReadMsgLineUp        = 0xFF73;
-const Key KK_ReadMsgPgDn          = 0xFF74;
-const Key KK_ReadMsgPgUp          = 0xFF75;
-const Key KK_ReadNewArea          = 0xFF76;
-const Key KK_ReadNewMsg           = 0xFF77;
-const Key KK_ReadQuitNow          = 0xFF78;
-const Key KK_ReadQuoteBuf         = 0xFF79;
-const Key KK_ReadQuoteMsg         = 0xFF7A;
-const Key KK_ReadReplyMsg         = 0xFF7B;
-const Key KK_ReadSearch           = 0xFF7C;
-const Key KK_ReadSoundkill        = 0xFF7D;
-const Key KK_ReadStealTagline     = 0xFF7E;
-const Key KK_ReadThreadtree       = 0xFF7F;
-const Key KK_ReadToggleBookMark   = 0xFF80;
-const Key KK_ReadToggleHexdump    = 0xFF81;
-const Key KK_ReadToggleHidden     = 0xFF82;
-const Key KK_ReadToggleHiddKlud   = 0xFF83;
-const Key KK_ReadToggleKludge     = 0xFF84;
-const Key KK_ReadToggleMark       = 0xFF85;
-const Key KK_ReadToggleMarkRead   = 0xFF86;
-const Key KK_ReadTogglePageBar    = 0xFF87;
-const Key KK_ReadToggleQuote      = 0xFF88;
-const Key KK_ReadToggleRealMsgno  = 0xFF89;
-const Key KK_ReadToggleROT13      = 0xFF8A;
-const Key KK_ReadToggleStyles     = 0xFF8B;
-const Key KK_ReadToggleTwits      = 0xFF8C;
-const Key KK_ReadTouchNetscan     = 0xFF8D;
-const Key KK_ReadTouchSemaphore   = 0xFF8E;
-const Key KK_ReadUserbase         = 0xFF8F;
-const Key KK_ReadUUDecode         = 0xFF90;
-const Key KK_ReadWriteMsg         = 0xFF91;
-
-const Key KK_AreaUndefine         = 0xFFA0;
-const Key KK_EditUndefine         = 0xFFA1;
-const Key KK_FileUndefine         = 0xFFA2;
-const Key KK_ListUndefine         = 0xFFA3;
-const Key KK_NodeUndefine         = 0xFFA4;
-const Key KK_ReadUndefine         = 0xFFA5;
-
-const Key KK_ZzzzLast             = 0xFFA6;
+const Key KK_ZzzzLast             = 0xFFB6;
 
 
diff -u2 -r goldware.2/golded3/geview.cpp goldware/golded3/geview.cpp
--- goldware.2/golded3/geview.cpp	Sat Nov 21 21:38:02 1998
+++ goldware/golded3/geview.cpp	Tue Mar 23 15:20:46 1999
@@ -439,9 +439,6 @@
 
   // Print it
-  vputns(vrow, 0, color, line->text, visible_width);
-  if(not SearchHighlight(line, vrow, visible_width, highlight_color)) {
-    if(CFG->switches.get(stylecodes))
-      StyleCodeHighlight(line->text, vrow, 0, CFG->hidestylies, color, (VidPutStrCP)vputs);
-  }
+  vputns(vrow, strlen(line->text), color, "", visible_width-strlen(line->text));
+  StyleCodeHighlight(line->text, vrow, 0, CFG->hidestylies, color, (VidPutStrCP)vputs);
 }
 
diff -u2 -r goldware.2/golded3/golded3.all goldware/golded3/golded3.all
--- goldware.2/golded3/golded3.all	Sat Nov 21 21:38:02 1998
+++ goldware/golded3/golded3.all	Tue Mar 23 14:45:44 1999
@@ -62,4 +62,5 @@
 genode   cpp all ovl bcd bco bcx djg emx lnx rsx wcn wco wcx
 geplay   cpp all ovl bcd bco bcx djg emx lnx rsx wcn wco wcx
+gepmclip cpp all nov     bco         emx             wco    
 gepost   cpp all ovl bcd bco bcx djg emx lnx rsx wcn wco wcx
 geqwks   cpp all ovl bcd bco bcx djg emx lnx rsx wcn wco wcx
diff -u2 -r goldware.2/goldlib/gall/gkbdbase.cpp goldware/goldlib/gall/gkbdbase.cpp
--- goldware.2/goldlib/gall/gkbdbase.cpp	Sat Feb  6 16:00:22 1999
+++ goldware/goldlib/gall/gkbdbase.cpp	Tue Mar 23 15:21:58 1999
@@ -757,4 +757,11 @@
   k = (Key)cpu.r.w.ax;
 
+  if(((mode & ~0x10) == 0) and (KCodAsc(k) == 0xE0) and (KCodScn(k) != 0)) {
+    if(kbxget_raw(2) & (LSHIFT | RSHIFT)) {
+      KCodAsc(k) = 0;
+      KCodScn(k) |= 0x80;
+    }
+  }
+
   #elif defined(__OS2__)
 
@@ -783,6 +790,9 @@
   else {
     if(0xE0 == KCodAsc(k))
-      if(KCodScn(k))
+      if(KCodScn(k)) {
         KCodAsc(k) = 0x00;
+        if(kb.fsState & (LSHIFT | RSHIFT))
+          KCodScn(k) |= 0x80;
+      }
   }
 
diff -u2 -r goldware.2/goldlib/gall/gkbdcode.h goldware/goldlib/gall/gkbdcode.h
--- goldware.2/goldlib/gall/gkbdcode.h	Sat Nov 21 21:38:08 1998
+++ goldware/goldlib/gall/gkbdcode.h	Tue Mar 23 09:06:40 1999
@@ -54,4 +54,6 @@
 //  ------------------------------------------------------------------
 
+#include <gdefs.h>
+
 
 //  ------------------------------------------------------------------
@@ -209,8 +211,4 @@
 #define  Key_S_Del   0x532E          // S <Del .>            N - - -
 #define  Key_S_DelG  0x53E0          // S <Del>     Grey     - G E T
-#define  Key_S_Dwn   0x5032          // S <Down 2>           N - - -
-#define  Key_S_DwnG  0x50E0          // S <Down>    Grey     - G E T
-#define  Key_S_End   0x4F31          // S <End 1>            N - - -
-#define  Key_S_EndG  0x4FE0          // S <End>     Grey     - G E T
 #define  Key_S_F1    0x5400          // S <F1>               - - - -
 #define  Key_S_F2    0x5500          // S <F2>               - - - -
@@ -225,4 +223,16 @@
 #define  Key_S_F11   0x8700          // S <F11>              - - E -
 #define  Key_S_F12   0x8800          // S <F12>              - - E -
+#define  Key_S_Tab   0x0F00          // S <Tab>              - - - -
+#if defined(__OS2__) or defined(__MSDOS__)
+#define  Key_S_Ins   0xD200          // S <Ins>     Grey     - G E T
+#define  Key_S_Lft   0xCB00          // S <Left>    Grey     - G E T
+#define  Key_S_PgDn  0xD100          // S <PgDn>    Grey     - G E T
+#define  Key_S_PgUp  0xC900          // S <PgUp>    Grey     - G E T
+#define  Key_S_Rgt   0xCD00          // S <Right>   Grey     - G E T
+#define  Key_S_Up    0xC800          // S <Up>      Grey     - G E T
+#define  Key_S_Dwn   0xD000          // S <Down>    Grey     - G E T
+#define  Key_S_End   0xCF00          // S <End>     Grey     - G E T
+#define  Key_S_Home  0xC700          // S <Home>    Grey     - G E T
+#else
 #define  Key_S_Home  0x4737          // S <Home 7>           N - - -
 #define  Key_S_HomeG 0x47E0          // S <Home>    Grey     - G E T
@@ -237,7 +247,11 @@
 #define  Key_S_Rgt   0x4D36          // S <Right 6>          N - - -
 #define  Key_S_RgtG  0x4DE0          // S <Right>   Grey     - G E T
-#define  Key_S_Tab   0x0F00          // S <Tab>              - - - -
 #define  Key_S_Up    0x4838          // S <Up 8>             N - - -
 #define  Key_S_UpG   0x48E0          // S <Up>      Grey     - G E T
+#define  Key_S_Dwn   0x5032          // S <Down 2>           N - - -
+#define  Key_S_DwnG  0x50E0          // S <Down>    Grey     - G E T
+#define  Key_S_End   0x4F31          // S <End 1>            N - - -
+#define  Key_S_EndG  0x4FE0          // S <End>     Grey     - G E T
+#endif
 
 //  ------------------------------------------------------------------
diff -u2 -r goldware.2/goldlib/gall/gkbdgetm.cpp goldware/goldlib/gall/gkbdgetm.cpp
--- goldware.2/goldlib/gall/gkbdgetm.cpp	Sat Nov 21 21:38:06 1998
+++ goldware/goldlib/gall/gkbdgetm.cpp	Tue Mar 23 15:23:00 1999
@@ -131,4 +131,6 @@
       if(xshift & ALT)
         xkey = Key_A_HomeG;
+      if(xshift & (LSHIFT | RSHIFT))
+        KCodScn(xkey) |= 0x80;
       break;
 
@@ -137,4 +139,6 @@
       if(xshift & ALT)
         xkey = Key_A_EndG;
+      if(xshift & (LSHIFT | RSHIFT))
+        KCodScn(xkey) |= 0x80;
       break;
 
@@ -144,4 +148,6 @@
       else if(xshift & CTRL)
         xkey = Key_C_Up;
+      if(xshift & (LSHIFT | RSHIFT))
+        KCodScn(xkey) |= 0x80;
       break;
 
@@ -151,4 +157,6 @@
       else if(xshift & CTRL)
         xkey = Key_C_Dwn;
+      if(xshift & (LSHIFT | RSHIFT))
+        KCodScn(xkey) |= 0x80;
       break;
 
@@ -156,4 +164,6 @@
       if(xshift & ALT)
         xkey = Key_A_LftG;
+      if(xshift & (LSHIFT | RSHIFT))
+        KCodScn(xkey) |= 0x80;
       break;
 
@@ -161,4 +171,6 @@
       if(xshift & ALT)
         xkey = Key_A_RgtG;
+      if(xshift & (LSHIFT | RSHIFT))
+        KCodScn(xkey) |= 0x80;
       break;
 
@@ -166,4 +178,6 @@
       if(xshift & ALT)
         xkey = Key_A_PgUpG;
+      if(xshift & (LSHIFT | RSHIFT))
+        KCodScn(xkey) |= 0x80;
       break;
 
@@ -171,4 +185,6 @@
       if(xshift & ALT)
         xkey = Key_A_PgDnG;
+      if(xshift & (LSHIFT | RSHIFT))
+        KCodScn(xkey) |= 0x80;
       break;
 
@@ -178,4 +194,6 @@
       else if(xshift & CTRL)
         xkey = Key_C_Ins;
+      if(xshift & (LSHIFT | RSHIFT))
+        KCodScn(xkey) |= 0x80;
       break;
 
@@ -185,4 +203,6 @@
       else if(xshift & CTRL)
         xkey = Key_C_Del;
+      if(xshift & (LSHIFT | RSHIFT))
+        KCodScn(xkey) |= 0x80;
       break;
   }
diff -u2 -r goldware.2/goldlib/gall/gutlclip.cpp goldware/goldlib/gall/gutlclip.cpp
--- goldware.2/goldlib/gall/gutlclip.cpp	Tue Mar 23 07:17:48 1999
+++ goldware/goldlib/gall/gutlclip.cpp	Tue Mar 23 15:24:10 1999
@@ -168,5 +168,5 @@
     }
     strtrim(strxcpy(buffer, clipdata, ++i));
-    strcat(buffer, "\n");
+    if (p) strcat(buffer, "\n");
     len -= i;
     clipdata += i;
diff -u2 -N -r goldware.2/golded3/gepmclip.cpp goldware/golded3/gepmclip.cpp
--- goldware.2/golded3/gepmclip.cpp	Thu Jan  1 00:00:00 1970
+++ goldware/golded3/gepmclip.cpp	Tue Mar 23 14:59:52 1999
@@ -0,0 +1,99 @@
+
+//  ------------------------------------------------------------------
+//  GoldED. Copyright (C) Odinn Sorensen.
+//  ------------------------------------------------------------------
+//  This program is free software; you can redistribute it and/or
+//  modify it under the terms of the GNU General Public License as
+//  published by the Free Software Foundation; either version 2 of the
+//  License, or (at your option) any later version.
+//
+//  This program is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+//  General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with this program; if not, write to the Free Software
+//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+//  ------------------------------------------------------------------
+//  $Id: gepmclip.cpp,v 1.0 1999/03/22 14:42:20 damware Exp $
+//  ------------------------------------------------------------------
+//  OS/2 clipboard to/from edit paste buffer.
+//  ------------------------------------------------------------------
+
+
+#include "golded.h"
+
+#include "geedit.h"
+#include "gutlclip.h"
+
+void IEclass::Clip2Buf() {
+
+  gclipbrd clipbrd;
+
+  if(!clipbrd.openread())
+    return;
+
+  // Allocate paragraph read buffer
+  char *buf = (char *)throw_malloc(EDIT_PARABUFLEN);
+  Line *__line = NULL;
+
+  // Read paragraphs
+  while(clipbrd.read(buf, EDIT_PARABUFLEN-6)) {
+
+    // Replace tabs with single spaces
+    strchg(buf, HT, ' ');
+
+    // Translate softcr to configured char
+    if(EDIT->SoftCrXlat())
+      strchg(buf, SOFTCR, EDIT->SoftCrXlat());
+
+    // Copy the paragraph to the new line and retype it
+    Line* _newline = __line = insertlinebelow(__line, buf);
+    if(Edit__pastebuf == NULL)
+      Edit__pastebuf = _newline;
+    setlinetype(_newline);
+
+    // If the paragraph is longer than one line
+    uint _wrapmargin = (_newline->type & GLINE_QUOT) ? marginquotes : margintext;
+    if(strlen(_newline->text) >= _wrapmargin) {
+
+      // Wrap it
+      uint _tmpcol = 0;
+      uint _tmprow = 0;
+      _newline = wrapins(&_newline, &_tmpcol, &_tmprow, NO);
+    }
+
+    __line = _newline;
+  }
+  clipbrd.close();
+}
+
+
+void IEclass::Buf2Clip() {
+
+  gclipbrd clipbrd;
+  int buflen = 0;
+  Line *_bufline;
+
+  for(_bufline = Edit__pastebuf; _bufline; _bufline = _bufline->next)
+    buflen += strlen(_bufline->text) + 1;
+
+  char *clipdata = (char *)malloc(buflen);
+  if(clipdata == NULL)
+    return;
+
+  char *curptr = clipdata;
+  *curptr = NUL;
+  for(_bufline = Edit__pastebuf; _bufline; _bufline = _bufline->next) {
+    strcpy(curptr, _bufline->text);
+    if(*curptr) {
+      curptr += strlen(curptr) - 1;
+      if(*curptr == '\n') strcpy(curptr, "\r\n");
+    }
+    curptr += strlen(curptr);
+  }
+
+  clipbrd.writeclipbrd(clipdata);
+  free(clipdata);
+}
