diff -u2 -r golded-3.0.1/gbuild/Makefile goldware/gbuild/Makefile
--- golded-3.0.1/gbuild/Makefile	Fri Jan  8 11:08:44 1999
+++ goldware/gbuild/Makefile	Mon Mar 22 11:32:02 1999
@@ -40,5 +40,8 @@
 
 emx :
-	@gcc -s -O2 -funsigned-char -Wall -I../goldlib/gall -o gbldemx gbuild.cpp
+	@gcc -s -O2 -funsigned-char -Wall -I../goldlib/gall -o gbldemx.exe gbuild.cpp -lstdcpp
+
+omf :
+	@gcc -s -O2 -Zomf -Zcrtdll -funsigned-char -Wall -I../goldlib/gall -o gbldomf.exe gbuild.cpp -lstdcpp
 
 lnx :
diff -u2 -r golded-3.0.1/gbuild/gbuild.cpp goldware/gbuild/gbuild.cpp
--- golded-3.0.1/gbuild/gbuild.cpp	Sun Nov 22 17:32:26 1998
+++ goldware/gbuild/gbuild.cpp	Mon Mar 22 11:10:40 1999
@@ -80,4 +80,5 @@
     const char* formats = argv[5];
     int data_arg = 6;
+    bool gnu_omf = false;
 
     int type = 0;
@@ -100,4 +101,8 @@
     else if(strieql(formats, "dos"))
       format = format_dos;
+    else if(strieql(formats, "omf")) {
+      format = format_gnu;
+      gnu_omf = true;
+    }
 
     ifstream ifp;
@@ -157,5 +162,5 @@
                     << filename
                     << '.'
-                    << (format == format_gnu ? "o" : "obj")
+                    << ((format == format_gnu and not gnu_omf) ? "o" : "obj")
                     << ' '
                     << (format == format_watcom ? '&' : '\\')
diff -u2 -r golded-3.0.1/golded3/Makefile goldware/golded3/Makefile
--- golded-3.0.1/golded3/Makefile	Sun Dec 27 18:08:10 1998
+++ goldware/golded3/Makefile	Mon Mar 22 10:18:06 1999
@@ -50,4 +50,8 @@
 	@$(MAKE) -f bldgnu.mak PLATFORM_EMX=1 TARGET=$(TARGET) TARGETSHORT=$(TARGETSHORT) DEPTH=$(DEPTH) TARGETEXT=.exe
 
+omf :
+	@$(MAKE) -f $(DEPTH)/bldlists.mak TARGET=$(TARGET) bldomf.inc
+	@$(MAKE) -f bldgnu.mak PLATFORM_OMF=1 TARGET=$(TARGET) TARGETSHORT=$(TARGETSHORT) DEPTH=$(DEPTH) TARGETEXT=.exe
+
 lnx :
 	@$(MAKE) -f $(DEPTH)/bldlists.mak TARGET=$(TARGET) bldlnx.inc
diff -u2 -r golded-3.0.1/golded3/bldgnu.mak goldware/golded3/bldgnu.mak
--- golded-3.0.1/golded3/bldgnu.mak	Fri Jan  8 11:08:44 1999
+++ goldware/golded3/bldgnu.mak	Mon Mar 22 10:11:40 1999
@@ -24,5 +24,5 @@
 TARGETEXE=$(TARGETSHORT)$(PLATFORM)
 CFLAGS2=-I$(DEPTH)/gcfg -I$(DEPTH)/gmb3
-LIBS=$(LIBPATH)/libgmb3.a $(LIBPATH)/libgall.a $(LIBPATH)/libgcfg.a
+LIBS=$(LIBPATH)/libgmb3.$(a) $(LIBPATH)/libgall.$(a) $(LIBPATH)/libgcfg.$(a)
 include $(DEPTH)/mkexegnu.mak
 
diff -u2 -r golded-3.0.1/goldlib/bldlists.mak goldware/goldlib/bldlists.mak
--- golded-3.0.1/goldlib/bldlists.mak	Sat Nov 21 21:37:58 1998
+++ goldware/goldlib/bldlists.mak	Mon Mar 22 09:29:58 1999
@@ -43,14 +43,17 @@
 
 blddjg.inc : $(LISTFILE)
-	@gbuild.exe $(LISTFILE) blddjg.inc $(GOBJG)/djg/$(TARGET) inc gnu djg
+	@gbuild.exe $(LISTFILE) blddjg.inc $(GOBJ)/djg/$(TARGET) inc gnu djg
 
 bldemx.inc : $(LISTFILE)
-	@gbuild.exe $(LISTFILE) bldemx.inc $(GOBJG)/emx/$(TARGET) inc gnu emx
+	@gbuild.exe $(LISTFILE) bldemx.inc $(GOBJ)/emx/$(TARGET) inc gnu emx
+
+bldomf.inc : $(LISTFILE)
+	@gbuild.exe $(LISTFILE) bldomf.inc $(GOBJ)/omf/$(TARGET) inc omf emx
 
 bldlnx.inc : $(LISTFILE)
-	@gbuild $(LISTFILE) bldlnx.inc $(GOBJG)/lnx/$(TARGET) inc gnu lnx
+	@gbuild $(LISTFILE) bldlnx.inc $(GOBJ)/lnx/$(TARGET) inc gnu lnx
 
 bldrsx.inc : $(LISTFILE)
-	@gbuild.exe $(LISTFILE) bldrsx.inc $(GOBJG)/rsx/$(TARGET) inc gnu rsx
+	@gbuild.exe $(LISTFILE) bldrsx.inc $(GOBJ)/rsx/$(TARGET) inc gnu rsx
 
 ##  ------------------------------------------------------------------
diff -u2 -r golded-3.0.1/goldlib/gall/Makefile goldware/goldlib/gall/Makefile
--- golded-3.0.1/goldlib/gall/Makefile	Sun Dec 27 18:08:10 1998
+++ goldware/goldlib/gall/Makefile	Mon Mar 22 08:34:18 1999
@@ -50,4 +50,8 @@
 	@$(MAKE) -f bldgnu.mak PLATFORM_EMX=1 TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH)
 
+omf :
+	@$(MAKE) -f $(DEPTH)/bldlists.mak TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH) bldomf.inc
+	@$(MAKE) -f bldgnu.mak PLATFORM_OMF=1 TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH)
+
 lnx :
 	@$(MAKE) -f $(DEPTH)/bldlists.mak TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH) bldlnx.inc
diff -u2 -r golded-3.0.1/goldlib/gall/gdbgerr.cpp goldware/goldlib/gall/gdbgerr.cpp
--- golded-3.0.1/goldlib/gall/gdbgerr.cpp	Sat Nov 21 21:38:06 1998
+++ goldware/goldlib/gall/gdbgerr.cpp	Mon Mar 22 08:50:48 1999
@@ -181,5 +181,5 @@
 
   gerrno = de.exterror;
-#elif defined(__linux__)
+#elif defined(__linux__) or defined(__EMX__)
   gerrno = errno;
 #else
diff -u2 -r golded-3.0.1/goldlib/gall/gio.h goldware/goldlib/gall/gio.h
--- golded-3.0.1/goldlib/gall/gio.h	Sat Nov 21 21:38:08 1998
+++ goldware/goldlib/gall/gio.h	Mon Mar 22 09:41:42 1999
@@ -33,4 +33,5 @@
 
 #if defined(__EMX__)
+#include <stdlib.h>
 #define getcwd _getcwd2
 #define chdir _chdir2
diff -u2 -r golded-3.0.1/goldlib/gcfg/Makefile goldware/goldlib/gcfg/Makefile
--- golded-3.0.1/goldlib/gcfg/Makefile	Sun Dec 27 18:08:12 1998
+++ goldware/goldlib/gcfg/Makefile	Mon Mar 22 08:46:32 1999
@@ -50,4 +50,8 @@
 	@$(MAKE) -f bldgnu.mak PLATFORM_EMX=1 TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH)
 
+omf :
+	@$(MAKE) -f $(DEPTH)/bldlists.mak TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH) bldomf.inc
+	@$(MAKE) -f bldgnu.mak PLATFORM_OMF=1 TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH)
+
 lnx :
 	@$(MAKE) -f $(DEPTH)/bldlists.mak TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH) bldlnx.inc
diff -u2 -r golded-3.0.1/goldlib/gmb3/Makefile goldware/goldlib/gmb3/Makefile
--- golded-3.0.1/goldlib/gmb3/Makefile	Sun Dec 27 18:08:12 1998
+++ goldware/goldlib/gmb3/Makefile	Mon Mar 22 08:47:12 1999
@@ -55,4 +55,8 @@
 	@$(MAKE) -f bldgnu.mak PLATFORM_EMX=1 TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH)
 
+omf : h2g
+	@$(MAKE) -f $(DEPTH)/bldlists.mak TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH) bldomf.inc
+	@$(MAKE) -f bldgnu.mak PLATFORM_OMF=1 TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH)
+
 lnx : h2g
 	@$(MAKE) -f $(DEPTH)/bldlists.mak TARGET=$(TARGET) SUBPATH=/$(SUBPATH) DEPTH=$(DEPTH) bldlnx.inc
diff -u2 -r golded-3.0.1/goldlib/mkexegnu.mak goldware/goldlib/mkexegnu.mak
--- golded-3.0.1/goldlib/mkexegnu.mak	Sun Jan 10 21:08:16 1999
+++ goldware/goldlib/mkexegnu.mak	Mon Mar 22 10:42:46 1999
@@ -32,5 +32,5 @@
 $(TARGETEXE)$(TARGETEXT): INIT $(DOBJS)
 	@echo Linking ...
-	@$(GGXX) $(DEBUG) -L$(OBJPATH) -o $(TARGETEXE)$(TARGETEXT) $(DIROBJS) $(LIBS)
+	@$(GGXX) $(LFLAGS) $(DEBUG) -L$(OBJPATH) -o $(TARGETEXE)$(TARGETEXT) $(DIROBJS) $(LIBS)
 ifdef PLATFORM_EMX
 	@emxbind -s gedemx
@@ -40,5 +40,5 @@
 ##  ------------------------------------------------------------------
 
-$(DOBJS) : %.o: %.cpp
+$(DOBJS) : %.$(o): %.cpp
 	@echo Compiling $< ...
 	@$(GGXX) -c $(CFLAGS) $< -o $(OBJPATH)/$(@F)
diff -u2 -r golded-3.0.1/goldlib/mklibgnu.mak goldware/goldlib/mklibgnu.mak
--- golded-3.0.1/goldlib/mklibgnu.mak	Mon Mar 22 10:57:26 1999
+++ goldware/goldlib/mklibgnu.mak	Mon Mar 22 11:11:00 1999
@@ -33,11 +33,15 @@
 ##  ------------------------------------------------------------------
 
-$(LIBPATH)/$(TARGET).a : $(DOBJS)
+$(LIBPATH)/$(TARGET).$(a) : $(DOBJS)
 	@echo Creating library ...
-	@ar crus $(LIBPATH)/lib$(TARGET).a $(DIROBJS)
+ifdef PLATFORM_OMF
+	@emxomfar ruc $(LIBPATH)/lib$(TARGET).$(a) $(DIROBJS)
+else
+	@ar crus $(LIBPATH)/lib$(TARGET).$(a) $(DIROBJS)
+endif
 
 ##  ------------------------------------------------------------------
 
-$(DOBJS) : %.o: %.cpp
+$(DOBJS) : %.$(o): %.cpp
 	@echo Compiling $< ...
 	@$(GGXX) -s -c $(CFLAGS) $< -o $(OBJPATH)/$(@F)
diff -u2 -r golded-3.0.1/goldlib/rulesgnu.mak goldware/goldlib/rulesgnu.mak
--- golded-3.0.1/goldlib/rulesgnu.mak	Sat Feb  6 16:00:22 1999
+++ goldware/goldlib/rulesgnu.mak	Mon Mar 22 10:42:02 1999
@@ -38,7 +38,15 @@
 PLATFORM=emx
 DEBUG=-g
-GNU27X=1
-GGXX=gxx
-CFLAGS3=-O2
+GGXX=gcc
+CFLAGS3=-O2
+LFLAGS=-Zcrtdll
+endif
+
+ifdef PLATFORM_OMF
+PLATFORM=omf
+DEBUG=
+GGXX=gcc
+CFLAGS3=-O2 -Zomf
+LFLAGS=-Zomf -Zcrtdll
 endif
 
@@ -82,9 +90,17 @@
 endif
 
+ifdef PLATFORM_OMF
+a=lib
+o=obj
+else
+a=a
+o=o
+endif
+
 CFLAGS=$(DEBUG) -Wall -funsigned-char $(CFLAGS1) $(CFLAGS3) $(CFLAGS2) -I$(GSRCG)/goldlib/gall -I$(GSRCG)/goldlib/gcfg -I$(GSRCG)/goldlib/gmb3
-vpath %.o $(OBJPATH)
+vpath %.$(o) $(OBJPATH)
 OBJS=$(objs)
 DOBJS=$(notdir $(OBJS))
-DIROBJS=$(patsubst %.o,$(OBJPATH)/%.o,$(DOBJS))
+DIROBJS=$(patsubst %.$(o),$(OBJPATH)/%.$(o),$(DOBJS))
 
 ##  ------------------------------------------------------------------
diff -u2 -r golded-3.0.1/goldnode/Makefile goldware/goldnode/Makefile
--- golded-3.0.1/goldnode/Makefile	Sun Dec 27 18:08:12 1998
+++ goldware/goldnode/Makefile	Tue Mar 23 02:49:16 1999
@@ -50,4 +50,8 @@
 	@$(MAKE) -f bldgnu.mak PLATFORM_EMX=1 TARGET=$(TARGET) TARGETSHORT=$(TARGETSHORT) DEPTH=$(DEPTH) TARGETEXT=.exe
 
+omf :
+	@$(MAKE) -f $(DEPTH)/bldlists.mak TARGET=$(TARGET) bldomf.inc
+	@$(MAKE) -f bldgnu.mak PLATFORM_OMF=1 TARGET=$(TARGET) TARGETSHORT=$(TARGETSHORT) DEPTH=$(DEPTH) TARGETEXT=.exe
+
 lnx :
 	@$(MAKE) -f $(DEPTH)/bldlists.mak TARGET=$(TARGET) bldlnx.inc
diff -u2 -r golded-3.0.1/goldnode/bldgnu.mak goldware/goldnode/bldgnu.mak
--- golded-3.0.1/goldnode/bldgnu.mak	Sat Feb  6 16:00:24 1999
+++ goldware/goldnode/bldgnu.mak	Tue Mar 23 02:49:46 1999
@@ -25,5 +25,5 @@
 TARGETEXE=$(TARGETSHORT)$(PLATFORM)
 CFLAGS2=-I../golded3
-LIBS=$(LIBPATH)/libgall.a
+LIBS=$(LIBPATH)/libgall.$(a)
 include $(DEPTH)/mkexegnu.mak
 
diff -u2 -r golded-3.0.1/goldnode/goldnode.cpp goldware/goldnode/goldnode.cpp
--- golded-3.0.1/goldnode/goldnode.cpp	Sun Feb  7 14:13:16 1999
+++ goldware/goldnode/goldnode.cpp	Tue Mar 23 02:52:26 1999
@@ -262,5 +262,5 @@
 //  ------------------------------------------------------------------
 
-#if defined(__UNIX__) or defined(__DJGPP__)
+#if defined(__UNIX__) or defined(__DJGPP__) or defined(__EMX__)
 #define fast_printf    if(not quiet) printf
 #define fast_putchar   if(not quiet) putchar
