diff -u2 -r goldware.1/golded3/gemnus.cpp goldware/golded3/gemnus.cpp
--- goldware.1/golded3/gemnus.cpp	Sat Nov 21 21:38:02 1998
+++ goldware/golded3/gemnus.cpp	Tue Mar 23 06:39:56 1999
@@ -404,5 +404,5 @@
     Item(TAG_BINMIME, LNG->ImportTxtMime);
 
-    #if defined(__WIN32__) //or defined(__OS2__)
+    #if defined(__WIN32__) or defined(__OS2__)
     Item(TAG_CLIPBRD, LNG->ImportTxtClip);
     #endif
diff -u2 -r goldware.1/goldlib/gall/gutlclip.cpp goldware/goldlib/gall/gutlclip.cpp
--- goldware.1/goldlib/gall/gutlclip.cpp	Sat Nov 21 21:38:06 1998
+++ goldware/goldlib/gall/gutlclip.cpp	Tue Mar 23 07:17:48 1999
@@ -1,3 +1,2 @@
-
 //  ------------------------------------------------------------------
 //  The Goldware Library. Copyright (C) Odinn Sorensen.
@@ -26,4 +25,5 @@
 #include <gutlmisc.h>
 #include <gutlclip.h>
+#include <gmemdbg.h>
 
 
@@ -37,6 +37,5 @@
   hglb = NULL;
   #endif
-  #if 0
-  //#ifdef __OS2__
+  #ifdef __OS2__
   whnd = NULL;
   #endif
@@ -60,26 +59,36 @@
   }
   #endif
-  #if 0
-  //#if defined(__OS2__)
-    SWCNTRL swctl;
 
-    WinQuerySwitchEntry(WinQuerySwitchHandle(0, getpid()), &swctl);
-    whnd = swctl.hwnd;
+  #if defined(__OS2__)
+  PTIB tib;
+  PPIB pib;
+  DosGetInfoBlocks(&tib, &pib);
 
-    whnd = WinInitialize(0);
+  oldtype = pib->pib_ultype;
+  pib->pib_ultype = 3;
 
-    if(whnd and WinOpenClipbrd(whnd)) {
+  whnd = WinInitialize(0);
+  whmq = WinCreateMsgQueue(whnd, 0);
 
-      if((clipdata = PCHAR(WinQueryClipbrdData(whnd, CF_TEXT)))!=NULL) {
-        printf("clipdata=%s\n", clipdata);
+  if(WinOpenClipbrd(whnd)) {
+    ULONG fmtinfo = 0;
 
-        //printf("len=%d\n", len = strlen(clipdata));
-        //len = 10;
-        //return true;
+    if(WinQueryClipbrdFmtInfo(whnd, CF_TEXT, &fmtinfo)) {
+      clipdata = (char *)WinQueryClipbrdData(whnd, CF_TEXT);
+      if(clipdata) {
+        len = strlen(clipdata);
+        return true;
       }
-      else
-        WinCloseClipbrd(whnd);
     }
-    WinTerminate(whnd);
+    WinCloseClipbrd(whnd);
+  }
+
+  WinDestroyMsgQueue(whmq);
+  WinTerminate(whnd);
+
+  pib->pib_ultype = oldtype;
+
+  if(clipdata)
+    return true;
   #endif
 
@@ -182,12 +191,15 @@
   }
   #endif
-  #if 0
-  //#if defined(__OS2__)
+  #if defined(__OS2__)
   if(len>=0) {
-    if(whnd) {
-      WinCloseClipbrd(whnd);
-      len = -1;
-      clipdata = NULL;
-    }
+    PTIB tib;
+    PPIB pib;
+    DosGetInfoBlocks(&tib, &pib);
+    WinCloseClipbrd(whnd);
+    WinDestroyMsgQueue(whmq);
+    WinTerminate(whnd);
+    pib->pib_ultype = oldtype;
+    len = -1;
+    clipdata = NULL;
   }
   #endif
diff -u2 -r goldware.1/goldlib/gall/gutlclip.h goldware/goldlib/gall/gutlclip.h
--- goldware.1/goldlib/gall/gutlclip.h	Sat Nov 21 21:38:08 1998
+++ goldware/goldlib/gall/gutlclip.h	Tue Mar 23 06:57:58 1999
@@ -69,4 +69,6 @@
   #ifdef __OS2__
   HAB whnd;
+  HMQ whmq;
+  ULONG oldtype;
   #endif
 
