--- golded-3.0.1\goldlib\gall\gvidbase.cpp	Sun Feb  7 14:13:14 1999
+++ goldware\goldlib\gall\gvidbase.cpp	Tue Mar 23 05:41:56 1999
@@ -376,4 +376,88 @@
 
 //  ------------------------------------------------------------------
+//  OS/2 Vio* wrappers for prevent 16-bit segment overrun
+
+#if defined(__OS2__)
+
+#ifndef _THUNK_PTR_SIZE_OK
+#define _THUNK_PTR_SIZE_OK(ptr,size) \
+  (((ULONG)(ptr) & ~0xffff) == (((ULONG)(ptr) + (size) - 1) & ~0xffff))
+#endif
+
+USHORT VioReadCellStr_(PCH str, PUSHORT pcb, USHORT row,
+    USHORT col, HVIO hvio) {
+  USHORT rc, cb = *pcb;
+
+  if(_THUNK_PTR_SIZE_OK(str, cb))
+    return VioReadCellStr(str, pcb, row, col, hvio);
+  PCH newstr = (PCH)malloc(cb * 2);
+  if(newstr == NULL)
+    return ERROR_NOT_ENOUGH_MEMORY;
+  if(_THUNK_PTR_SIZE_OK(newstr, cb)) {
+    rc = VioReadCellStr(newstr, pcb, row, col, hvio);
+    if(rc == 0)
+      memcpy(str, newstr, *pcb);
+  }
+  else {
+    rc = VioReadCellStr(newstr + cb, pcb, row, col, hvio);
+    if(rc == 0)
+      memcpy(str, newstr + cb, *pcb);
+  }
+  free(newstr);
+  return rc;
+}
+
+
+USHORT VioWrtCellStr_(PCCH str, USHORT cb, USHORT row,
+    USHORT col, HVIO hvio) {
+  USHORT rc;
+
+  if(_THUNK_PTR_SIZE_OK(str, cb ))
+    return VioWrtCellStr(str, cb, row, col, hvio);
+  PCH newstr = (PCH)malloc(cb * 2);
+  if(newstr == NULL)
+    return ERROR_NOT_ENOUGH_MEMORY;
+  if(_THUNK_PTR_SIZE_OK(newstr, cb)) {
+    memcpy(newstr, str, cb);
+    rc = VioWrtCellStr(newstr, cb, row, col, hvio);
+  }
+  else {
+    memcpy(newstr + cb, str, cb);
+    rc = VioWrtCellStr(newstr + cb, cb, row, col, hvio);
+  }
+  free(newstr);
+  return rc;
+}
+
+
+USHORT VioWrtCharStrAtt_(PCCH str, USHORT cb, USHORT row, USHORT col,
+    PBYTE attr, HVIO hvio) {
+  USHORT rc;
+
+  if(_THUNK_PTR_SIZE_OK(str, cb))
+    return VioWrtCharStrAtt(str, cb, row, col, attr, hvio);
+  PCH newstr = (PCH)malloc(cb * 2);
+  if(newstr == NULL)
+    return ERROR_NOT_ENOUGH_MEMORY;
+  if(_THUNK_PTR_SIZE_OK(newstr, cb)) {
+    memcpy(newstr, str, cb);
+    rc = VioWrtCharStrAtt(newstr, cb, row, col, attr, hvio);
+  }
+  else {
+    memcpy(newstr + cb, str, cb);
+    rc = VioWrtCharStrAtt(newstr + cb, cb, row, col, attr, hvio);
+  }
+  free(newstr);
+  return rc;
+}
+
+#define VioReadCellStr		VioReadCellStr_
+#define VioWrtCellStr		VioWrtCellStr_
+#define VioWrtCharStrAtt	VioWrtCharStrAtt_
+
+#endif  // __OS2__
+
+
+//  ------------------------------------------------------------------
 //  Print character and attribute at specfied location
 
